#include <stdio.h>
#include <stdlib.h>
#include <cyg/io/devtab.h>

#include "gfx.h"

cyg_io_handle_t fh;

void*   __dso_handle = (void*) &__dso_handle;

void
__cxa_atexit(void (*arg1)(void*), void* arg2, void* arg3)
{
}


typedef struct screen_info {
    unsigned char *base_buf;
    int width;
    int height;
    int bpp;
    int scanline;
} screen_info;

get_screen_info(screen_info *si)
{
    /* This is screen information. */
    si->base_buf = (unsigned char*) current_mode->physical_base_ptr;
    si->scanline = info_block->version >= 0x0300
	? current_mode->linear_bytes_per_scanline :
	current_mode->bytes_per_scanline;
    si->bpp = current_mode->bits_per_pixel / 8;
    si->width = current_mode->x_resolution;
    si->height = current_mode->y_resolution;
}

clear_screen(screen_info *si, unsigned color)
{
    memset(si->base_buf, color, si->scanline * si->height - 1);
}


int
main(int argc, char** argv)
{
    /* eCos puts the information we need here.   */
    info_block = (struct VBESVGAInfoBlock*) 0x000A0000;
    current_mode = (struct VBEModeInfoBlock*) 0x000A0200;
    screen_info si;

    get_screen_info(&si);
    clear_screen(&si, 128);
}
