#include <stdio.h>
#include "jpeglib.h"
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>

int main ()
{
    struct jpeg_decompress_struct cinfo;
    JSAMPARRAY buffer;		/* Output row buffer */
    int row_stride;		/* physical row width in output buffer */
    struct jpeg_error_mgr jerr;
    int fd;
    int i = 0;
    unsigned char *data;


    cinfo.err = jpeg_std_error(&jerr);
    cinfo.err->trace_level=10;
    jpeg_create_decompress(&cinfo);
    jpeg_mem_src(&cinfo);
    (void) jpeg_read_header(&cinfo, TRUE);
    (void) jpeg_start_decompress(&cinfo);
    row_stride = cinfo.output_width * cinfo.output_components;
    buffer = (*cinfo.mem->alloc_sarray)
	((j_common_ptr) &cinfo, JPOOL_IMAGE, row_stride, 1);

    fd = open("outfile", O_CREAT|O_WRONLY);
    fprintf(stderr, "%d %d %d %d\n", cinfo.output_width, cinfo.output_height,
	    cinfo.output_components, row_stride);

    data = (unsigned char*)malloc(cinfo.output_height * row_stride);
    memset(data, 50, cinfo.output_height * row_stride);


    while (cinfo.output_scanline < cinfo.output_height) {
	/* jpeg_read_scanlines expects an array of pointers to scanlines.
	 * Here the array is only one element long, but you could ask for
	 * more than one scanline at a time if that's more convenient.
	 */
	jpeg_read_scanlines(&cinfo, buffer, 1);
	/* Assume put_scanline_someplace wants a pointer and sample count. */
//	put_scanline_someplace(buffer[0], row_stride);
//	fprintf(stderr, "%d\n", row_stride);
	write(fd, buffer[0], row_stride);
    }
    close(fd);

    (void) jpeg_finish_decompress(&cinfo);
    jpeg_destroy_decompress(&cinfo);

    return 0;
}
